"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _domElementHelpers = require("./utils/dom-element-helpers");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var InfiniteScroll = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var children = props.children,
      dataLength = props.dataLength,
      loadMore = props.loadMore,
      hasMore = props.hasMore,
      loader = props.loader,
      threshold = props.threshold,
      parentRef = props.parentRef,
      startPage = props.startPage,
      loadFirstSetOnInit = props.loadFirstSetOnInit,
      resetDependencies = props.resetDependencies,
      disabled = props.disabled;
  var defaultThreshold = 250; // Initial state

  var _useState = (0, _react.useState)(startPage && startPage >= 0 ? startPage : 0),
      _useState2 = _slicedToArray(_useState, 2),
      firstPage = _useState2[0],
      setFirstPage = _useState2[1]; // Keep in state, so it won't change from props


  var _useState3 = (0, _react.useState)(firstPage),
      _useState4 = _slicedToArray(_useState3, 2),
      page = _useState4[0],
      setPage = _useState4[1];

  var _useState5 = (0, _react.useState)(dataLength),
      _useState6 = _slicedToArray(_useState5, 2),
      currentDataLength = _useState6[0],
      setCurrentDataLength = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = _slicedToArray(_useState7, 2),
      pagesLoaded = _useState8[0],
      setPagesLoaded = _useState8[1]; // Dependencies to array of dependencies


  var externalResetDependencies = Array.isArray(resetDependencies) ? resetDependencies : [resetDependencies]; // Reset

  var reset = function reset() {
    var resetTo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var resetToStartPage = resetTo.startPage;

    if (Number.isInteger(resetToStartPage) && resetToStartPage >= 0) {
      // Reset to passed first page
      setFirstPage(resetToStartPage);
      setPage(resetToStartPage);
    } else {
      // If start page not passed, reset to firstPage that component was initialized with
      setPage(firstPage);
    }

    setCurrentDataLength(dataLength);
    setPagesLoaded([]);
  }; // Expose data to ref


  (0, _react.useImperativeHandle)(ref, function () {
    return {
      reset: reset
    };
  }); // Reset all to initial state when reset dependencies change

  (0, _react.useEffect)(function () {
    reset();
  }, externalResetDependencies); // Trigger page change

  (0, _react.useEffect)(function () {
    if (!Number.isInteger(currentDataLength)) {
      console.error('InfiniteScroll: dataLength prop is not a number', currentDataLength);
    }

    if (dataLength > currentDataLength) {
      setPage(page + 1);
    }

    setCurrentDataLength(dataLength);
  }, [dataLength]); // Load next set of data

  (0, _react.useEffect)(function () {
    if (disabled) {
      return;
    }

    var parentElement = parentRef === null || parentRef === void 0 ? void 0 : parentRef.current;

    var handle = function handle() {
      var scrollPosition = parentElement ? parentElement.scrollTop + parentElement.offsetHeight : (0, _domElementHelpers.getBodyScrollPosition)() + window.innerHeight;
      var scrollHeight = parentElement ? parentElement.scrollHeight : (0, _domElementHelpers.getBodyScrollHeight)();
      var loadOnInit = loadFirstSetOnInit && page === firstPage;
      var thresholdExceeded = scrollHeight - scrollPosition < (threshold || defaultThreshold);
      var isPageLoaded = pagesLoaded.includes(page); // If there is more items to load and scroll position exceeds threshold, then load more items

      if ((loadOnInit || hasMore && thresholdExceeded) && !isPageLoaded) {
        setPagesLoaded([].concat(_toConsumableArray(pagesLoaded), [page]));
        loadMore(page);
      }
    }; // Initial run


    handle(); // Add event listener after load

    (parentElement || window).addEventListener('scroll', handle);
    (parentElement || window).addEventListener('resize', handle); // Cleanup

    return function () {
      (parentElement || window).removeEventListener('scroll', handle);
      (parentElement || window).removeEventListener('resize', handle);
    };
  }, [page, pagesLoaded, hasMore, disabled]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children, hasMore && loader);
});
var _default = InfiniteScroll;
exports["default"] = _default;