"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBodyScrollPosition = getBodyScrollPosition;
exports.getBodyScrollHeight = getBodyScrollHeight;

/**
 * Crossbrowser way to get body scroll position
 */
function getBodyScrollPosition() {
  return Math.max(document.documentElement && document.documentElement.scrollTop, document.body && document.body.scrollTop, document.scrollingElement && document.scrollingElement.scrollTop);
}
/**
 * Crossbrowser way to get body scroll height
 */


function getBodyScrollHeight() {
  return Math.max(document.documentElement && document.documentElement.scrollHeight, document.body && document.body.scrollHeight, document.scrollingElement && document.scrollingElement.scrollHeight);
}